<script language="JavaScript" type="text/javascript">
<!--

var currentDate, currentYear;

function weekOfYear(d)
{
    var year = d.getYear()
    if (year < 1900) {
        year += 1900;
    }
    var firstday = new Date(year, 0, 1);
    var firstwday = 8 - firstday.getDay();
    if (firstwday == 8) {
        firstwday = 1;
    } else if (firstwday > 4) {
        firstwday -= 7;
    }

    var dayofyear = (d - firstday.getTime() + 86400000) / 86400000;
    if (dayofyear < firstwday) {
        return weekOfYear(new Date(year - 1, 12, 31));
    } else {
        return Math.floor((dayofyear - firstwday) / 7) + 1;
    }
}

function openGoto(timestamp)
{
    var row, cell, link, days;

    var d = new Date(timestamp * 1000);
    currentDate = d;
    var month = d.getMonth();
    var year = d.getYear();
    if (year < 1900) {
        year += 1900;
    }
    currentYear = year;
    var firstOfMonth = new Date(year, month, 1);
    var diff = firstOfMonth.getDay() - 1;
    if (diff == -1) diff = 6;
    switch (month) {
        case 3:
        case 5:
        case 8:
        case 10:
            days = 30;
            break;
        case 1:
            if (year % 4 == 0 && (year % 100 != 0 || year % 400 == 0)) {
                days = 29;
            } else {
                days = 28;
            }
            break;
        default:
            days = 31;
            break;
    }

    var wdays = [
        '<?php echo _("Mo") ?>',
        '<?php echo _("Tu") ?>',
        '<?php echo _("We") ?>',
        '<?php echo _("Th") ?>',
        '<?php echo _("Fr") ?>',
        '<?php echo _("Sa") ?>',
        '<?php echo _("Su") ?>'
    ];
    var months = [
        '<?php echo _("January") ?>',
        '<?php echo _("February") ?>',
        '<?php echo _("March") ?>',
        '<?php echo _("April") ?>',
        '<?php echo _("May") ?>',
        '<?php echo _("June") ?>',
        '<?php echo _("July") ?>',
        '<?php echo _("August") ?>',
        '<?php echo _("September") ?>',
        '<?php echo _("October") ?>',
        '<?php echo _("November") ?>',
        '<?php echo _("December") ?>'
    ];

    var lay = document.getElementById('goto');
    if (lay.firstChild) {
        lay.removeChild(lay.firstChild);
    }

    var table = document.createElement('TABLE');
    var tbody = document.createElement('TBODY');
    table.appendChild(tbody);
    table.className = 'item';
    table.cellSpacing = 0;
    table.cellPadding = 2;
    table.border = 0;

    // month name
    row = document.createElement('TR');
    cell = document.createElement('TD');
    cell.className = 'header';
    cell.colSpan = 7;

    var itable = document.createElement('TABLE');
    var itbody = document.createElement('TBODY');
    itable.width = '100%';

    var irow = document.createElement('TR');
    var icell = document.createElement('TD');
    icell.align = 'left';
    link = document.createElement('A');
    link.href = '#';
    link.className = 'widget';
    link.onclick = function() {
        newDate = new Date(currentYear, currentDate.getMonth() - 1, currentDate.getDate());
        openGoto(newDate.getTime() / 1000);
    }
    var prev = document.createTextNode('< ');
    link.appendChild(prev);
    icell.appendChild(link);

    link = document.createElement('A');
    link.href = '#';
    link.className = 'widget';
    link.onclick = function() {
        newDate = new Date(currentYear, currentDate.getMonth() + 1, currentDate.getDate());
        openGoto(newDate.getTime() / 1000);
    }
    var next = document.createTextNode('> ');
    link.appendChild(next);
    icell.appendChild(link);

    var m = document.createTextNode(months[month]);
    icell.appendChild(m);

    irow.appendChild(icell);

    // year
    icell = document.createElement('TD');
    icell.align = 'right';

    var y = document.createTextNode(year);
    icell.appendChild(y);

    link = document.createElement('A');
    link.href = '#';
    link.className = 'widget';
    link.onclick = function() {
        newDate = new Date(currentYear - 1, currentDate.getMonth(), currentDate.getDate());
        openGoto(newDate.getTime() / 1000);
    }
    icell.appendChild(link);

    var prev = document.createTextNode(' < ');
    link.appendChild(prev);

    link = document.createElement('A');
    link.href = '#';
    link.className = 'widget';
    link.onclick = function() {
        newDate = new Date(currentYear + 1, currentDate.getMonth(), currentDate.getDate());
        openGoto(newDate.getTime() / 1000);
    }
    var next = document.createTextNode('>');
    link.appendChild(next);
    icell.appendChild(link);
    irow.appendChild(icell);

    // close
    icell = document.createElement('TD');
    icell.align = 'right';

    irow.appendChild(icell);

    // table row
    itbody.appendChild(irow);

    // finish inner table
    itable.appendChild(itbody);
    cell.appendChild(itable);
    row.appendChild(cell);
    tbody.appendChild(row);

    // weekdays
    row = document.createElement('TR');
    for (var i = 0; i < 7; i++) {
        cell = document.createElement('TD');
        weekday = document.createTextNode(wdays[i]);
        cell.appendChild(weekday);
        row.appendChild(cell);
    }
    tbody.appendChild(row);

    // rows
    var week, italic;
    var count = 1;
    var today = new Date();
    var odd = true;
    for (var i = 1; i <= days; i++) {
        if (count == 1) {
            row = document.createElement('TR');
            row.align = 'right';
            if (odd) {
                row.className = 'item0';
            } else {
                row.className = 'item1';
            }
            odd = !odd;
        }
        if (i == 1) {
            for (var j = 0; j < diff; j++) {
                cell = document.createElement('TD');
                row.appendChild(cell);
                count++;
            }
        }
        cell = document.createElement('TD');
        if (today.getYear() == year &&
            today.getMonth() == month &&
            today.getDate() == i) {
            cell.style.border = '1px solid red';
        }
        link = document.createElement('A');
        link.href = '<?php echo Util::addParameter(Horde::applicationUrl('bydate.php'), 'source', $source) ?>';
        if (link.href.indexOf('?') != -1) {
            link.href += '&';
        } else {
            link.href += '?';
        }
        link.href += 'year=' . year + '&month=' + (month + 1) + '&day=' + i;
        cell.appendChild(link);
        day = document.createTextNode(i);
        link.appendChild(day);
        row.appendChild(cell);
        if (count == 7) {
            tbody.appendChild(row);
            count = 0;
        }
        count++;
    }
    if (count > 1) {
        for (i = count; i <= 7; i++) {
            cell = document.createElement('TD');
            row.appendChild(cell);
        }
        tbody.appendChild(row);
    }

    // show Layer
    lay.appendChild(table);
    lay.style.visibility = 'visible';
}

// -->
</script>
