<?php

// Build the columns to display
$show = array();
$address = '';
foreach ($GLOBALS['columns'] as $column) {
    if ($ob->hasValue($column)) {
        $show[$column] = $ob->getValue($column);
        if ($GLOBALS['attributes'][$column]['type'] == 'email') {
            $mailbox_host = explode('@', $show[$column]);
            if (!isset($mailbox_host[1])) {
                $mailbox_host[1] = '';
            }
            $name = $ob->getValue('name');
            require_once 'Horde/MIME.php';
            $address = MIME::rfc822WriteAddress($mailbox_host[0], $mailbox_host[1], $name);

            // Get rid of the trailing @ (when no host is included in
            // the email address).
            $address = str_replace('@>', '>', $address);

            $show[$column] = '<a href="' . $GLOBALS['registry']->call('mail/compose', array(array('to' => $address))) . '">' . htmlspecialchars($show[$column]) . '</a>';
        } elseif ($GLOBALS['attributes'][$column]['type'] == 'date') {
            $show[$column] = date('m/d/Y h:m:s', $show[$column]);
        } else {
            $show[$column] = htmlspecialchars($show[$column]);
        }
    } else {
        $show[$column] = '&nbsp;';
    }
}

if ($ob->hasValue('__key')) {
    $url = 'displayobject.php';
    $url = Util::addParameter($url, 'source', $GLOBALS['source']);
    $url = Util::addParameter($url, 'key', $ob->getValue('__key'));
    $url = Util::addParameter($url, 'nomenu', 1);

    $label = sprintf(_("View '%s'"), $ob->getValue('number'));
    $cell = Horde::link('', $label, null, null,
                        "open_data_win('" . Horde::applicationUrl($url) . "'); return false;") .
        Horde::img('view.png', $label) . '</a>';
} else {
    $cell = '';
}

$class = 'text';
?>
<tr class="<?php echo $class ?>" onmouseover="className='<?php echo $class ?>'-hi;" onmouseout="className='<?php echo $class ?>';">
  <td valign="top"><?php echo $cell ?></td>
<?php foreach ($show as $field): ?>
  <td valign="top"><?php echo $field; ?></td>
<?php endforeach; ?>
</tr>
