<form name="quicksearch" action="query.php" method="post">
<input type="hidden" name="source" value="<?php echo htmlspecialchars($source) ?>" />
<input type="hidden" name="advanced" value="1" />
<?php Util::pformInput() ?>
<?php foreach ($quicksearch['criteria'] as $name => $val): ?>
<input type="hidden" name="<?php echo htmlspecialchars($name) ?>" value="<?php echo htmlspecialchars($val) ?>" />
<?php endforeach; ?>

<table border="0" align="center" width="100%" cellspacing="0" cellpadding="0"><tr>
 <td class="item" align="right" width="30%">
  <?php echo $quicksearch['title'] ?>&nbsp;&nbsp;
<?php if ($attributes[$quicksearch['field']]['type'] == 'yyyymmdd'): ?>
   <?php echo _("Starting:") ?><br /><?php echo ("Until:") ?>
 </td>
 <td class="item" nowrap="nowrap" width="10%">
   <?php echo Odin::buildMonthWidget($quicksearch['field'] . '[start][month]'); ?>
   <?php echo Odin::buildDayWidget($quicksearch['field'] . '[start][day]'); ?>
   <input type="text" name="<?php echo $quicksearch['field'] ?>[start][year]" size="4" value="" /><br />
   <?php echo Odin::buildMonthWidget($quicksearch['field'] . '[end][month]'); ?>
   <?php echo Odin::buildDayWidget($quicksearch['field'] . '[end][day]'); ?>
   <input type="text" name="<?php echo $quicksearch['field'] ?>[end][year]" size="4" value="" />
 </td>
<?php elseif ($attributes[$quicksearch['field']]['type'] == 'hh:mm:ss'): ?>
   <?php echo _("Starting:") ?><br /><?php echo ("Until:") ?>
 </td>
 <td class="item" nowrap="nowrap" width="60%">
  <?php echo Odin::buildHourWidget($quicksearch['field'] . '[start][hour]'); ?>
  <?php echo Odin::buildMinuteWidget($quicksearch['field'] . '[start][min]'); ?><br />
  <?php echo Odin::buildHourWidget($quicksearch['field'] . '[end][hour]'); ?>
  <?php echo Odin::buildMinuteWidget($quicksearch['field'] . '[end][min]'); ?>
 </td>
<?php else: ?>
 </td>
 <td><input type="text" size="30" name="<?php echo $quicksearch['field'] ?>" /></td>
<?php endif; ?>
 <td nowrap="nowrap" width="80%">
  <input class="button" type="submit" value="<?php echo _("Search") ?>" />
 </td>
</tr></table>
</form>
<br />
