<table width="100%" cellpadding="2" cellspacing="0" border="0">
<tr>
  <td class="header">
    <b><?php echo htmlspecialchars(str_replace('%INPUT%', $input, $summary['title'])) ?>&nbsp;</b>
  </td>
</tr>
<tr>
  <td class="item">
<?php
if ($summary['type'] == 'value') {
    echo is_a($result, 'PEAR_Error') ? $result->getMessage() : $result;
} elseif ($summary['type'] == 'array') {
    $data = array_flip($result);

    require_once 'Horde/Graph.php';
    $graph = &new Horde_Graph(array('width' => 500, 'height' => 300, 'temp' => Horde::getTempDir()));
    $graph->set('offsetGridX', .5);
    $graph->addXData(array_keys($data));
    $graph->addPlot('bar', array('dataset' => $graph->addYData(array_values($data))));
    echo $graph->display();
} else {
    echo _("Not a supported summary type.");
}
?>
  </td>
</tr>
</table>
<br />
